---
# All hosts here are in groups "Moodle" and "frontend"

# Call configuration tasks
# All frontends
- name: Prepare directories
  ansible.builtin.include_tasks: frontend_directories.yml

- name: Perform package installation
  ansible.builtin.package:
    name: "{{ moodle_packages }}"
    state: present
  register: taskresults
  until: taskresults is ansible.builtin.success
  retries: 3
  delay: 1

- name: Configure apache
  ansible.builtin.include_tasks: frontend_apache.yml

- name: Get Moodle from git
  ansible.builtin.include_tasks: frontend_git_access.yml

- name: Configure PHP
  ansible.builtin.include_tasks: frontend_php_config.yml

- name: Enable webserver ports
  ansible.posix.firewalld:
    service: "{{ item }}"
    permanent: true
    immediate: true
    state: enabled
  loop:
    - http
    - https
  notify: Restart firewall

- name: Configure git access
  ansible.builtin.include_tasks: frontend_git_access.yml

- name: Install Shibboleth
  ansible.builtin.include_tasks: frontend_shibboleth.yml
  when: inventory_hostname_short not in groups.Development

- name: Start webserver
  ansible.builtin.service:
    name: httpd
    state: started

# Frontends with cronjob task
- name: Perform cronjob installation
  ansible.builtin.template:
    src: php_crontasks
    dest: /etc/cron.d/php_crontasks
    owner: root
    group: root
    mode: "0644"
  when:
    - moodle_frontend.cronjob_host is defined
    - moodle_frontend.cronjob_host == inventory_hostname_short

# Frontends with Tivoli backup
- name: Perform Tivoli backup installation
  ansible.builtin.include_role:
    name: let.services.backup_client.yml
  when: >
    (groups.backup is defined and inventory_hostname_short in groups.backup)
    or (moodle_frontend.dbr_hosts is defined and inventory_hostname_short in moodle_frontend.dbr_hosts)

# Frontends with 'coursebackup' duty
- name: Perform coursebackup installation
  ansible.builtin.include_tasks: frontend_coursebackup.yml
  when:
    - moodle_frontend.coursebackup_host is defined
    - moodle_frontend.coursebackup_host == inventory_hostname_short
